#ifndef __SHADERENV_H
#define __SHADERENV_H


////////////
//-- ssao + gi parameters
#define NUM_PRECOMPUTED_SAMPLES 4096
//#define NUM_SAMPLES 8
//#define NUM_SAMPLES 16
//#define NUM_SAMPLES 24
#define NUM_SAMPLES 8

//#define MIN_SAMPLES 48
#define MIN_SAMPLES 8

#define DISTANCE_SCALE 1e-2f

//#define ILLUM_INTENSITY 8e-2f
#define ILLUM_INTENSITY 5e-3f
/// scale factor that takes angle of sample normal into account 
#define VIEW_CORRECTION_SCALE 1.0f

#define SSAO_CONVERGENCE_THRESHOLD 700.0f
//#define SSAO_CONVERGENCE_THRESHOLD 1500.0f


////////
//-- reprojection

//#define MIN_DEPTH_DIFF 5e-3f
#define MIN_DEPTH_DIFF 1e-3f
#define DYNAMIC_OBJECTS_THRESHOLD 1e-8f


/////////
//-- shadowing

#define NUM_PCF_TABS 16


//////////
//-- Tone mapping

#define MINLOGLUM (-10.0f)
#define MAXLOGLUM 10.0f

#define INV_LOGLUM_RANGE 0.05f
#define LOGLUM_RANGE 20.0f

#define MAX_LOD_LEVEL 10
/// burnout (really bright regions will be saturated to white)
#define WHITE_LUMINANCE 3e4f

#define TONE_MAPPING_EXPONENTIAL_FACTOR 1e-1f


///////////////////

#define NUM_DOWNSAMPLES 9

#define NUM_DOF_TABS 16

//#define USE_GTX

#define SSAO_FILTER_RADIUS 5

#define DEPTH_THRESHOLD 1e10f


#endif // __SHADERENV_H